(function(){
  var Map, classes, Observable, LinkableModel;
  Map = require('immutable').Map;
  classes = function(){
    var clss, i$, len$, c, r, k, v;
    clss = [];
    for (i$ = 0, len$ = (arguments).length; i$ < len$; ++i$) {
      c = (arguments)[i$];
      if (c == null) {
        continue;
      }
      switch (typeof c) {
      case 'string':
        clss.push(c);
        break;
      case 'object':
        if ((r = (fn$())).length) {
          clss.splice(0, 0, r);
        }
      }
    }
    return clss.join(' ');
    function fn$(){
      var ref$, results$ = [];
      switch (false) {
      case !Array.isArray(c):
        return reactex.classes.apply(null, c);
      default:
        for (k in ref$ = c) {
          v = ref$[k];
          if (v) {
            results$.push(k);
          }
        }
        return results$;
      }
    }
  };
  Observable = (function(){
    Observable.displayName = 'Observable';
    var prototype = Observable.prototype, constructor = Observable;
    function Observable(){
      this._subscribers = Map().asMutable();
      this._sid = 0;
    }
    Observable.prototype.sub = function(o){
      var id, this$ = this;
      while (this._subscribers.get(id = this._sid) != null) {
        ++this._sid;
      }
      this._subscribers.set(id, o);
      return function(it){
        return it.bind(this$, id);
      }(function(id){
        return this._subscribers.remove(id);
      });
    };
    Observable.prototype.notifyAll = function(data){
      var this$ = this;
      this._subscribers.forEach((function(it){
        return it(data);
      }));
    };
    return Observable;
  }());
  LinkableModel = (function(superclass){
    var prototype = extend$((import$(LinkableModel, superclass).displayName = 'LinkableModel', LinkableModel), superclass).prototype, constructor = LinkableModel;
    function LinkableModel(dflt){
      LinkableModel.superclass.call(this);
      this.model = this._dflt = Map(dflt);
    }
    LinkableModel.prototype.link = function(key, arg$){
      var inKey, outKey, pipe, i$, ref$, len$, ref1$, k, v, this$ = this, resultObj$ = {};
      if (arg$ != null) {
        inKey = arg$.inKey, outKey = arg$.outKey, pipe = arg$.pipe;
      }
      for (i$ = 0, len$ = (ref$ = [
        [inKey != null ? inKey : 'value', this.model.get(key)], [
          outKey != null ? outKey : 'onChange', bound(this, key, pipe != null
            ? pipe
            : fn$, fn1$)
        ]
      ]).length; i$ < len$; ++i$) {
        ref1$ = ref$[i$], k = ref1$[0], v = ref1$[1];
        resultObj$[k] = v;
      }
      return resultObj$;
      function fn$(it){
        return it.target.value;
      }
      function fn1$(key, pipe, it){
        this.notifyAll(this.model = this.model.set(key, pipe(it)));
      }
    };
    LinkableModel.prototype.linkDatepicker = function(key){
      return this.link(key, {
        inKey: 'selected',
        pipe: function(it){
          return it;
        }
      });
    };
    LinkableModel.prototype.reset = function(){
      return this.notifyAll(this.model = this._dflt);
    };
    return LinkableModel;
  }(Observable));
  module.exports = {
    classes: classes,
    Observable: Observable,
    LinkableModel: LinkableModel,
    AutoreleaseMixin: {
      getInitialState: function(){
        this.__am_autoreleases = [];
        return null;
      },
      autoreleasing: function(fn){
        this.__am_autoreleases.push(fn);
        return fn;
      },
      componentWillUnmount: function(){
        var i$, ref$, len$, fn;
        for (i$ = 0, len$ = (ref$ = this.__am_autoreleases).length; i$ < len$; ++i$) {
          fn = ref$[i$];
          fn();
        }
        this.__am_autoreleases = [];
      }
    }
  };
  function extend$(sub, sup){
    function fun(){} fun.prototype = (sub.superclass = sup).prototype;
    (sub.prototype = new fun).constructor = sub;
    if (typeof sup.extended == 'function') sup.extended(sub);
    return sub;
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
}).call(this);
